/*
 * MyPanel.java
 *
 * Created on Utorok, 2004, oktber 12, 20:41
 */

/**
 *
 * @author  m
 */

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.*;
import javax.swing.*;
import graphics.math.*;
import graphics.device.*;
import graphics.geometry.*;

public class MyPanel extends JPanel implements Runnable, ImageProducer
{
	int _width;
	int _height;
	Image _image;
	Thread _thread;
	ImageConsumer _consumer;
	DirectColorModel _model;
	int frame = 0;
	float fps = 100.f;
	public boolean flat=false;
	public boolean pause=false;
	
	
	/** Creates a new instance of MyPanel */
	public MyPanel()
	{
	//	this.setBackground(new Color(255,0,0));
	//	this.setDoubleBuffered(false);
		_width = getWidth();
		_height = getHeight();
		_image = Toolkit.getDefaultToolkit().createImage(this);
		_model = new DirectColorModel(32,0x00FF0000,0x000FF00,0x000000FF,0);
	}
	
	public void run()
	{
		GL gl = new GL(_width,_height);
		gl.clearColorBuffer(0);
		long time = System.currentTimeMillis();
		frame = 0;
		fps = -1;
		float angle_y=0;
		float angle_z=0;
		mat m = new mat();
		int frameAll=0;
		float tcol=0;
		gl.gluPerspective(45.f, (float)gl.sizeX/(float)gl.sizeY, 0.1f, 100.f);
	//	int ret = col.mul(0xff7f0a, 0.5f);
	//	System.out.println(Integer.toHexString(ret));
		gl.glLightModelAmbient(0x000000);
		gl.glEnableLighting();
		Material mat = new Material();
		mat.ambient = 0xffffff;
		mat.diffuse = 0xffffff;
		mat.specular = 0xffffff;
		mat.shininess = 32.f;
		gl.glMaterial(mat);
		Light light = new Light();
		light.ambient = 0;
		light.diffuse = 0xff0000;
		light.specular = 0xffffff;
		light.position.set(0,0,5);
		light.isObjectSpace = false;
		light.directional = false;
		gl.glAddLight(light);
		
		light.ambient = 0;
		light.diffuse = 0x00ff00;
		light.specular = 0xffffff;
		light.position.set(1,0,0);
		light.isObjectSpace = false;
		light.directional = true;
		gl.glAddLight(light);

		light.ambient = 0;
		light.diffuse = 0x0000ff;
		light.specular = 0xffffff;
		light.position.set(0,1,0);
		light.isObjectSpace = false;
		light.directional = true;
		gl.glAddLight(light);
		Sphere sp = new Sphere();
		sp.Init(50,100,1.5f);
		
		gl.glEnableCullFace();
		
		while(true)
		{
			frame++;
			frameAll++;
			gl.clearColorBuffer(0);
							
			if(!pause)
			{
				angle_y+=50.f/fps;
				angle_z+=70.f/fps;
				if(angle_y>360.f)angle_y-=360.f;
				if(angle_z>360.f)angle_z-=360.f;
			}
			m.Identity();
			m.Translate( 0, 0, -5.0f);
			m.RotY(angle_y);
		//	m.RotZ(angle_z);
			gl.glLoadViewMatrix(m);
			gl.glRecomputeLightPositions();
			
			if(flat)
				gl.glShadeModel(gl.GL_FLAT);
			else
				gl.glShadeModel(gl.GL_SMOOTH);
			
		//	if(frameAll==1)	System.out.println(gl.viewProj.toString());
			
		//	Sphere.DrawSphereBase(gl, 50, 100, 1.5f);
			sp.Draw(gl);
			
		/*	v a = new v(0,2.0f,0);
			a.RotZ(120.f);
			gl.glBegin(gl.GL_TRIANGLES);
			gl.glNormal3fv(new v(0,0,1));
			gl.glColor3fv( 0xff0000);
			gl.glVertex3fv(new v(a)); a.RotZ( 120.f);
			gl.glColor3fv( 0x00ff00);
			gl.glVertex3fv(new v(a)); a.RotZ( 120.f);
			gl.glColor3fv( 0x0000ff);
			gl.glVertex3fv(new v(a));
			gl.glEnd();*/
		/*	gl.glBegin(gl.GL_TRIANGLES);
			gl.glColor3fv( 0xff0000);
			gl.glVertex3f(-1.5f, -1, 0);
			gl.glColor3fv( 0x7f7f00);
			gl.glVertex3f( 0, -1, 0);
			gl.glColor3fv( 0x0000ff);
			gl.glVertex3f( 0,  1, 0);
			gl.glEnd();
			gl.glBegin(gl.GL_TRIANGLES);
			gl.glColor3fv( 0x7f7f00);
			gl.glVertex3f( 0, -1, 0);
			gl.glColor3fv( 0x00ff00);
			gl.glVertex3f( 1.5f, -1, 0);
			gl.glColor3fv( 0x0000ff);
			gl.glVertex3f( 0,  1, 0);
			gl.glEnd();*/
			
		/*	// Front Face
			gl.glColor3fv( 0xff0000);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f(-1.0f, -1.0f,  1.0f);
			gl.glVertex3f( 1.0f, -1.0f,  1.0f);
			gl.glVertex3f(-1.0f,  1.0f,  1.0f);
			gl.glVertex3f( 1.0f,  1.0f,  1.0f);
			gl.glEnd();
			// Back Face
			gl.glColor3fv( 0x00ff00);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f(-1.0f, -1.0f, -1.0f);
			gl.glVertex3f(-1.0f,  1.0f, -1.0f);
			gl.glVertex3f( 1.0f, -1.0f, -1.0f);
			gl.glVertex3f( 1.0f,  1.0f, -1.0f);
			gl.glEnd();
			// Top Face
			gl.glColor3fv( 0x0000ff);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f(-1.0f,  1.0f, -1.0f);
			gl.glVertex3f(-1.0f,  1.0f,  1.0f);
			gl.glVertex3f( 1.0f,  1.0f, -1.0f);
			gl.glVertex3f( 1.0f,  1.0f,  1.0f);
			gl.glEnd();
			// Bottom Face
			gl.glColor3fv( 0xff00ff);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f(-1.0f, -1.0f, -1.0f);
			gl.glVertex3f( 1.0f, -1.0f, -1.0f);
			gl.glVertex3f(-1.0f, -1.0f,  1.0f);
			gl.glVertex3f( 1.0f, -1.0f,  1.0f);
			gl.glEnd();
			// Right face
			gl.glColor3fv( 0xffff00);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f( 1.0f, -1.0f, -1.0f);
			gl.glVertex3f( 1.0f,  1.0f, -1.0f);
			gl.glVertex3f( 1.0f, -1.0f,  1.0f);
			gl.glVertex3f( 1.0f,  1.0f,  1.0f);
			gl.glEnd();
			// Left Face
			gl.glColor3fv( 0xffffff);
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			gl.glVertex3f(-1.0f, -1.0f, -1.0f);
			gl.glVertex3f(-1.0f, -1.0f,  1.0f);
			gl.glVertex3f(-1.0f,  1.0f, -1.0f);
			gl.glVertex3f(-1.0f,  1.0f,  1.0f);
			gl.glEnd();*/
		 
			update(gl.cBuf);
			if(System.currentTimeMillis() - time > 0)
			{
			//	System.out.println(Long.toString(System.currentTimeMillis() - time));
				float minTime = 0.001f*(float)(System.currentTimeMillis() - time);
				if(fps<0)
					fps = (float)frame/minTime;
				else
					fps = 0.1f*(float)frame/minTime + 0.9f*fps;;
				frame = 0;
				time = System.currentTimeMillis();
			}
		}
	}
	
	public int resizePanel(int width, int height)
	{
		int started = 0;
		if (_thread!=null && _thread.isAlive())
		{
			stop();
			started = 1;
		}
		_width = width;
		_height = height;
		if(_consumer!=null)
			_consumer.setDimensions(_width,_height);
		_image = Toolkit.getDefaultToolkit().createImage(this);
		return started;
	}
	public void setBounds(int x, int y, int width, int height)
	{
		int started = resizePanel(width,height);
		super.setBounds( x, y, width, height);
		if(started==1)start();
	}
	public void setBounds(Rectangle r)
	{
		int started = resizePanel(r.width,r.height);
		super.setBounds(r);
		if(started==1)start();
	}
	public void setSize(Dimension d)
	{
		int started = resizePanel(d.width,d.height);
		super.setSize(d);
		if(started==1)start();
	}
	public void setSize(int width,int height)
	{
		int started = resizePanel(width,height);
		super.setSize(width,height);
		if(started==1)start();		
	}

	public void start()
	{
        if (_thread==null)					// check thread
        {
			_thread = new Thread(this);		// create thread
            _thread.start();				// start thread
        }		
	}
	
	public void stop()
	{
		if (_thread!=null && _thread.isAlive())		// check thread is valid and alive
		{
			_thread.stop();	// stop thread
		}
		_thread = null;			// null thread
	}
	
	public synchronized void addConsumer(java.awt.image.ImageConsumer ic)
	{
		// register image consumer
		_consumer = ic;

		// set image dimensions
		_consumer.setDimensions(_width,_height);

		// set image consumer hints for speed
		_consumer.setHints(ImageConsumer.TOPDOWNLEFTRIGHT|ImageConsumer.COMPLETESCANLINES|ImageConsumer.SINGLEPASS|ImageConsumer.SINGLEFRAME);

		// set image color model
		_consumer.setColorModel(_model);
	}
	
	public synchronized boolean isConsumer(java.awt.image.ImageConsumer ic)
	{
		// check if consumer is registered
		return true;
	}
	
	public synchronized void removeConsumer(java.awt.image.ImageConsumer ic)
	{
		// remove image consumer
	}
	
	public void requestTopDownLeftRightResend(java.awt.image.ImageConsumer ic)
	{
		// ignore resend request
	}
	
	public synchronized void startProduction(java.awt.image.ImageConsumer ic)
	{
		// add consumer
		addConsumer(ic);
	}
	
	public synchronized void update(int[] pixels)
	{
		// check consumer
		if (_consumer!=null && pixels.length==_width*_height )
		{
			// copy integer pixel data to image consumer
			_consumer.setPixels(0,0,_width,_height,_model,pixels,0,_width);

			// notify image consumer that the frame is done
			_consumer.imageComplete(ImageConsumer.SINGLEFRAMEDONE);
		}

		// paint
		if(_image!=null)
		{
			Graphics g = getGraphics();
			g.drawImage(_image,0,0,_width,_height,null);
			
			g.setColor(new Color(255,255,255));
		//	g.fillRect(10,3, 100, 15);
		//	g.setColor(new Color(0,0,0));
			g.drawString(Float.toString(fps), 15, 15);
		}
	}
	public synchronized void paint(Graphics g)
	{
		if(_image!=null)
		{
			g.drawImage(_image,0,0,_width,_height,null);
			
			g.setColor(new Color(255,255,255));
		//	g.fillRect(10,3, 70, 15);
		//	g.setColor(new Color(0,0,0));
			g.drawString(Float.toString(fps), 15, 15);
		}		
	}
}
