/*
 * Light.java
 *
 * Created on Nedee, 2004, oktber 31, 15:26
 */

package graphics.device;
import graphics.math.*;
/**
 *
 * @author  Marek Mizanin
 */
public class Light
{
	public int ambient;
	public int diffuse;
	public int specular;
	public v   position;
	// position in object space
	// if(isObjectSpace)position_obj_sp=position; else position_obj_sp = (view.Inverse())*position;
	public v   position_obj_sp;
//	public v   attenuation;	// x = constant, y = linear, z = quadratic attenuation factor
	public boolean directional;	// if true light is direction else is point light
	// if isObjectSpace is false, position is transformed from camera space to object space
	public boolean isObjectSpace;	// ak je nastavene, pouzije sa suradnicova sustava objektu

	public Light()
	{
		ambient = 0;
		diffuse = 0xffffff;
		specular = 0;
		position = new v(0,0,1);
		position_obj_sp = new v(0,0,1);
		directional = true;
		isObjectSpace = false;
	}
	public Light(Light a)
	{
		ambient = a.ambient;
		diffuse = a.diffuse;
		specular = a.specular;
		position = new v(a.position);
		position_obj_sp = new v(a.position_obj_sp);
		directional = a.directional;
		isObjectSpace = a.isObjectSpace;
	//	attenuation = a.attenuation;
	}
	
}
