/*
 * MainForm.java
 *
 * Created on Sobota, 2004, oktber 16, 15:07
 */

/**
 *
 * @author  Marek Mizanin
 */

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

public class MainForm extends javax.swing.JFrame implements WindowListener, ActionListener
{
	MyPanel pan=null;
	JButton startBut,stopBut;
	JCheckBox pauseBut;
	JRadioButton ortho,perspektiv;
	/** Creates a new instance of MainForm */
	public MainForm()
	{
		initComponents();
		this.setTitle("J004_lights");
	}
	
	private void initComponents()
	{
		addWindowListener(this);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		initLookAndFeel();
	//	getContentPane().setLayout(null);
		
	/*	ortho = new JRadioButton("Flat");
		ortho.addActionListener(this);
		perspektiv = new JRadioButton("Smooth");
		perspektiv.addActionListener(this);
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(1,2));
		ButtonGroup skupina = new ButtonGroup();

		panel.add(ortho);
		skupina.add(ortho);
		panel.add(perspektiv);
		skupina.add(perspektiv);
		getContentPane().add(panel);
		panel.setBounds(220,  5, 190, 20);*/
		
	/*	startBut = new JButton("Start");
		startBut.addActionListener(this);
		getContentPane().add(startBut);
		startBut.setBounds(10,  5, 60, 20);
		
		stopBut = new JButton("Stop");
		stopBut.addActionListener(this);
		getContentPane().add(stopBut);
		stopBut.setBounds(80,  5, 60, 20);
		
		pauseBut = new JCheckBox("Pause");
		pauseBut.addActionListener(this);
		getContentPane().add(pauseBut);
		pauseBut.setBounds(145,  5, 65, 20);*/
		
		pan = new MyPanel();
		getContentPane().add(pan);
	//	pan.setBounds(10, 30, 400, 300);
		this.setSize(420, 340);
	}
	public void setBoundsPan()
	{
		if(pan!=null)
		{
			System.out.println(getWidth());
			pan.setBounds(10, 30, Math.max(getWidth()-20,400), Math.max(getHeight()-40,300));
		}
	}
	public void setBounds(int x, int y, int width, int height)
	{
		super.setBounds( x, y, width, height);
		setBoundsPan();
	}
	public void setBounds(Rectangle r)
	{
		super.setBounds(r);
		setBoundsPan();
	}
	public void setSize(int width,int height)
	{
		super.setSize(width,height);
		setBoundsPan();	
	}
	public void setSize(Dimension d)
	{
		super.setSize(d);
		setBoundsPan();	
	}
	
	public void start()
	{
		pan.start();
	}
	
	public void stop()
	{
		pan.stop();
	}
	
	public static void main(String args[])
	{
	//	new MainForm().show();
		MainForm a = new MainForm();
		a.show();
	//	a.start();
	}
	
	
	public void initLookAndFeel()
	{
		// Force SwingApplet to come up in the System L&F
		String laf = UIManager.getSystemLookAndFeelClassName();
		try 
		{
			UIManager.setLookAndFeel(laf);
			// UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
			// UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			// UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
			// UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} 
		catch (UnsupportedLookAndFeelException exc) 
		{
			System.err.println("Warning: UnsupportedLookAndFeel: " + laf);
		}
		catch (Exception exc) 
		{
			System.err.println("Error loading " + laf + ": " + exc);
		}
	}
	
	public void windowOpened(java.awt.event.WindowEvent windowEvent)
	{
		start();
	}
	
	public void windowClosing(java.awt.event.WindowEvent windowEvent)
	{
		stop();
	}

	public void windowClosed(java.awt.event.WindowEvent windowEvent)
	{
		stop();
	}
	
	public void windowDeiconified(java.awt.event.WindowEvent windowEvent)
	{
		start();
	}
	
	public void windowIconified(java.awt.event.WindowEvent windowEvent)
	{
		stop();
	}
		
	public void windowActivated(java.awt.event.WindowEvent windowEvent)
	{
	//	start();
	}
	
	public void windowDeactivated(java.awt.event.WindowEvent windowEvent)
	{
	//	stop();
	}

	public void actionPerformed(java.awt.event.ActionEvent e)
	{
		String arg = e.getActionCommand();
		if("Start".equals(arg))
		{
			start();
		}
		else if("Pause".equals(arg))
		{
			pan.pause = !pan.pause;
		}
		else if("Stop".equals(arg))
		{
			stop();
		}
		else if("Flat".equals(arg))
		{
			pan.flat = true;
		}
		else if("Smooth".equals(arg))
		{
			pan.flat = false;
		}
	}
	
}
