/*
 * vi.java
 *
 * Created on Piatok, 2004, oktber 15, 13:39
 */

/**
 *
 * @author  Marek Mizanin
 * This class is 2D vector, use integer
 */
package graphics.math;

import graphics.math.v;

public class vi
{
	public int x,y;
	/** Creates a new instance of vi */
	public vi(){}
	public vi(int x_, int y_){x = x_; y = y_;}
	public vi(vi a){x = a.x; y = a.y;}
	public vi(v a){x = Math.round(a.x); y = Math.round(a.y);}
	public void set(int x_, int y_, int z_){x = x_; y = y_;}
	public void clear(){x = 0; y = 0 ;}
	public void neg(){x = -x; y = -y;}
	
	public void add(vi a){x+=a.x; y+=a.y;}
	public void sub(vi a){x-=a.x; y-=a.y;}
	public void mul(vi a){x*=a.x; y*=a.y;}
	public void div(vi a){x/=a.x; y/=a.y;}
	
	public void add(int a){x+=a; y+=a;}
	public void sub(int a){x-=a; y-=a;}
	public void mul(int a){x*=a; y*=a;}
	public void div(int a){x/=a; y/=a;}
		
	static public vi add(vi a, vi b){return new vi(a.x+b.x, a.y+b.y);}
	static public vi sub(vi a, vi b){return new vi(a.x-b.x, a.y-b.y);}
	static public vi mul(vi a, vi b){return new vi(a.x*b.x, a.y*b.y);}
	static public vi div(vi a, vi b){return new vi(a.x/b.x, a.y/b.y);}
	
	static public vi add(vi a, int b){return new vi(a.x+b, a.y+b);}
	static public vi sub(vi a, int b){return new vi(a.x-b, a.y-b);}
	static public vi mul(vi a, int b){return new vi(a.x*b, a.y*b);}
	static public vi div(vi a, int b){return new vi(a.x/b, a.y/b);}
	
	static public vi add(int a, vi b){return new vi(a+b.x, a+b.y);}
	static public vi sub(int a, vi b){return new vi(a-b.x, a-b.y);}
	static public vi mul(int a, vi b){return new vi(a*b.x, a*b.y);}
	static public vi div(int a, vi b){return new vi(a/b.x, a/b.y);}	
	
	static public boolean less(vi a, vi b)		{return ((a.x< b.x)&&(a.y< b.y));}
	static public boolean lessEqual(vi a, vi b)	{return ((a.x<=b.x)&&(a.y<=b.y));}
	static public boolean great(vi a, vi b)		{return ((a.x> b.x)&&(a.y> b.y));}
	static public boolean greatEqual(vi a, vi b){return ((a.x>=b.x)&&(a.y>=b.y));}
	static public boolean equal(vi a, vi b)		{return ((a.x==b.x)&&(a.y==b.y));}
	static public boolean noEqual(vi a, vi b)	{return ((a.x!=b.x)&&(a.y!=b.y));}
}
